<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Transactions" %>

<script runat="server">

    protected void btnSave_Click(object sender, EventArgs e)
    {
        CommittableTransaction trans = new CommittableTransaction();
        try
        {
            string connectionString = ConfigurationManager.ConnectionStrings["pubsConnectionString"].ConnectionString;
            using (SqlConnection connection = new SqlConnection(connectionString))
            {
                string sql = "Insert into Dept(Name, Description) Values(@Name, @Description)";
                connection.Open(); 
                SqlCommand command = new SqlCommand(sql, connection);
                command.CommandType = CommandType.Text;
                SqlParameter nameParam = new SqlParameter("@Name", SqlDbType.VarChar, 20);
                nameParam.Value = txtDeptName.Text;
                command.Parameters.Add(nameParam);
                SqlParameter descParam = new SqlParameter("@Description", SqlDbType.VarChar, 50);
                descParam.Value = txtDescription.Text;
                command.Parameters.Add(descParam);
                //Enlist the transaction in the scope of the current transaction 
                connection.EnlistTransaction(trans);
                command.ExecuteNonQuery();
                //Commit the transaction if everything executed successfully
                trans.Commit();
            }
            Response.Write("Dept is written successfully");
        }
        catch (Exception ex)
        {
            //Rollback the transaction if there is an exception
            trans.Rollback();
            Response.Write("Exception is : " + ex.Message);            
        }
    }
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Using Explicit Transactions using CommittableTransaction</title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:Label ID="lblDeptName" runat="server" Text="Dept Name:" Width="179px"></asp:Label>        
        <asp:TextBox ID="txtDeptName" runat="server"></asp:TextBox>
        <br/><br/><br/>
        <asp:Label ID="lblDescription" runat="server" Text="Description" Width="177px"></asp:Label>        
        <asp:TextBox ID="txtDescription" runat="server"></asp:TextBox>
        &nbsp;<br/><br/>        
        <asp:Button ID="btnSave" runat="server" Text="Save" Width="92px" OnClick="btnSave_Click" /></div>
    </form>
</body>
</html>
