using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Transactions;
using System.Data.SqlClient;


/// <summary>
/// Summary description for Dept
/// </summary>
public class Dept
{
	public Dept()
	{
		//
		// TODO: Add constructor logic here
		//
	}

	public bool InsertDeptWithTransactionScope(string deptName, string description)
	{		
		string connectionString = ConfigurationManager.ConnectionStrings["pubsConnectionString"].ConnectionString;
		using (TransactionScope scope = new TransactionScope())
		{
			
			using (SqlConnection connection = new SqlConnection(connectionString))
			{
				string sql = "Insert into Dept(Name, Description) Values(@Name, @Description)";
				connection.Open(); //this auto-enlists in the transaction scope.
				SqlCommand command = new SqlCommand(sql,connection);
				command.CommandType = CommandType.Text;
				SqlParameter nameParam = new SqlParameter("@Name", SqlDbType.VarChar,20);
				nameParam.Value = deptName;
				command.Parameters.Add(nameParam);
				SqlParameter descParam = new SqlParameter("@Description", SqlDbType.VarChar,50);
				descParam.Value = description;
				command.Parameters.Add(descParam);
				command.ExecuteNonQuery();
				
			}
			//When the TransactionScope is disposed it will check the Consistent property. 
			//If this is true the DTC will commit, if it is false it will roll back.
			//scope.Consistent = true;
			scope.Complete();
		}		
		return true;
	}

	public bool InsertDeptWithCommittableTransaction(string deptName, string description)
	{
		CommittableTransaction trans = new CommittableTransaction();
		try
		{
			string connectionString = ConfigurationManager.ConnectionStrings["pubsConnectionString"].ConnectionString;		
			using (SqlConnection connection = new SqlConnection(connectionString))
			{
				string sql = "Insert into Dept(Name, Description) Values(@Name, @Description)";
				connection.Open(); //this auto-enlists in the transaction scope.
				SqlCommand command = new SqlCommand(sql, connection);
				command.CommandType = CommandType.Text;
				SqlParameter nameParam = new SqlParameter("@Name", SqlDbType.VarChar, 20);
				nameParam.Value = deptName;
				command.Parameters.Add(nameParam);
				SqlParameter descParam = new SqlParameter("@Description", SqlDbType.VarChar, 50);
				descParam.Value = description;
				command.Parameters.Add(descParam);
				//Enlist the transaction in the scope of the current transaction 
				connection.EnlistTransaction(trans);				
				command.ExecuteNonQuery();
				//Commit the transaction if everything executed successfully
				trans.Commit();
			}
		}
		catch(Exception ex)
		{
			//Rollback the transaction if there is an exception
			trans.Rollback();
			return false;
		}
		return true;
	}
}
